unit MainUnit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.ListView.Types, FMX.ListView.Appearances, FMX.ListView.Adapters.Base,
  Data.Bind.GenData, System.Rtti, System.Bindings.Outputs, Fmx.Bind.Editors,
  Data.Bind.EngExt, Fmx.Bind.DBEngExt, Data.Bind.Components,
  Data.Bind.ObjectScope, FMX.ListView, FMX.Controls.Presentation, FMX.StdCtrls,
  System.ImageList, FMX.ImgList, FireDAC.Stan.Intf,
  FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf,
  FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys,
  FireDAC.Phys.FB, FireDAC.Phys.FBDef, FireDAC.FMXUI.Wait, FireDAC.Stan.Param,
  FireDAC.DatS, FireDAC.DApt.Intf, FireDAC.DApt, Data.DB, FireDAC.Comp.DataSet,
  FireDAC.Comp.Client, FireDAC.Comp.ScriptCommands, FireDAC.Stan.Util,
  FireDAC.Comp.Script, FMX.DateTimeCtrls, FMX.TabControl, FMX.ScrollBox, FMX.Memo,
  FMX.Layouts, Fmx.Bind.GenData;

type
  TMainForm = class(TForm)
    lstViewSimple: TListView;
    PrototypeBindSource1: TPrototypeBindSource;
    BindingsList1: TBindingsList;
    LinkListControlToField1: TLinkListControlToField;
    LstViewDyn: TListView;
    Tous: TButton;
    Button2: TButton;
    Layout1: TLayout;
    LstViewAvecImage: TListView;
    ImageList1: TImageList;
    LinkListControlToField2: TLinkListControlToField;
    LstViewDyn_plus: TListView;
    LinkFillControlToField2: TLinkFillControlToField;
    Panneaux: TTabControl;
    Simple: TTabItem;
    Dynamique: TTabItem;
    ImageList: TTabItem;
    Dynamique_plus: TTabItem;
    Switch1: TSwitch;
    Label1: TLabel;
    Memo1: TMemo;
    Switch2: TSwitch;
    Label2: TLabel;
    Memo2: TMemo;
    Groupes: TTabItem;
    ListViewGroupe: TListView;
    LinkFillControlToField3: TLinkFillControlToField;
    LinkFillControlToField4: TLinkFillControlToField;
    LinkFillControlToField1: TLinkFillControlToField;
    Switch3: TSwitch;
    Label3: TLabel;
    procedure LstViewDynItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure LstViewDynButtonClick(const Sender: TObject;
      const AItem: TListItem; const AObject: TListItemSimpleControl);
    procedure TousClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure LstViewAvecImageItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure LstViewDyn_plusItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure Switch1Switch(Sender: TObject);
    procedure lstViewSimpleItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure Switch2Switch(Sender: TObject);
    procedure ListViewGroupeItemClick(const Sender: TObject;
      const AItem: TListViewItem);
    procedure ListViewGroupeButtonClick(const Sender: TObject;
      const AItem: TListItem; const AObject: TListItemSimpleControl);
    procedure Switch3Switch(Sender: TObject);
  private
    { Dclarations prives }
    procedure UpdateItem(Item : TListViewItem);
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.fmx}
uses FMX.ListView.DynamicAppearance;

procedure TMainForm.TousClick(Sender: TObject);
var Item : TListViewItem;
begin
if TButton(Sender).Tag=0
  then begin
   TButton(Sender).Text:='UnCheck all';
   TButton(Sender).Tag:=1;
   LstViewDyn_plus.Items.CheckAll(True);
  end
  else begin
   TButton(Sender).Text:='Check all';
   TButton(Sender).Tag:=0;
   LstViewDyn_plus.Items.CheckAll(False);
  end;
  for Item in LstViewDyn_plus.Items do UpdateItem(Item);
end;

procedure TMainForm.UpdateItem(Item: TListViewItem);
var AListItemBitmap : TListItemImage;
    AListItemText : TListItemText;
    ACheckBox : TListItemGlyphButton;
    AColor : TAlphaColor;
begin
AListItemBitmap:=Item.Objects.FindObjectT<TListItemImage>('Image');
if Assigned(AListItemBitmap) then
 begin
     AListItemBitmap.OwnsBitmap:=True; // ici la modification
     AListItemBitmap.Bitmap:=TBitmap.Create(4,4);
     if Item.Checked then AColor:=TAlphaColorRec.Aquamarine
                      else AColor:=TAlphaColorRec.Null;
     AListItemBitmap.Bitmap.Clear(Acolor);
 end;
AListItemText:=Item.Objects.FindObjectT<TListItemText>('Text1');
if Assigned(AListItemText) then
     if Item.Checked then AListItemText.Font.Style:=[TFontStyle.fsBold]
                      else AListItemText.Font.Style:=[];
if Item.HasClickOnSelectItems then
 begin
   ACheckBox:=Item.Objects.FindObjectT<TListItemGlyphButton>('GlyphButton2');
   if Assigned(ACheckBox) AND (ACheckBox.ButtonType=TGlyphButtonType.Checkbox)
     then ACheckBox.Checked:=Item.Checked;
 end;

end;

procedure TMainForm.Button2Click(Sender: TObject);
var aListView : TListView;
begin
case Panneaux.TabIndex of
 0 : aListView:=LstViewSimple;
 1 : aListView:=LstViewAvecImage;
 2 : aListView:=lstViewDyn;
 3 : aListView:=lstViewDyn_plus;
 4 : aListView:=ListViewGroupe;
end;
showmessage(aListView.Items.CheckedCount.tostring);
end;

procedure TMainForm.lstViewSimpleItemClick(const Sender: TObject;
  const AItem: TListViewItem);
var  AListItemText : TListItemText;
begin
if not LstViewSimple.EditMode then
  LstViewSimple.Items.SetChecked(AItem.Index,not Aitem.Checked);
  AListItemText:=AItem.Objects.TextObject;
  if AItem.Checked then begin
                         AListItemText.Font.Style:=[TFontStyle.fsBold];
  //                       AListItemText.TextColor:=TAlphaColorRec.Red;
                    end
                   else begin
                     AListItemText.Font.Style:=[];
  //                   AListItemText.TextColor:=TAlphaColorRec.black;
                   end;
end;

procedure TMainForm.LstViewDynButtonClick(const Sender: TObject;
  const AItem: TListItem; const AObject: TListItemSimpleControl);
begin
if AObject.ClassNameIs('TListItemGlyphButton') then
  begin
    TListItemGlyphButton(AObject).Checked:=not TListItemGlyphButton(AObject).Checked;
  end;
end;

procedure TMainForm.LstViewDynItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
if not LstViewDyn.EditMode then
  LstViewDyn.Items.SetChecked(AItem.Index,not Aitem.Checked);
UpdateItem(AItem);
end;

procedure TMainForm.ListViewGroupeButtonClick(const Sender: TObject;
  const AItem: TListItem; const AObject: TListItemSimpleControl);
var
  I: Integer;
  Status : Boolean;
  AListItemText : TListItemText;
  AListTextButton : TListItemTextButton;
begin
ListViewGroupe.BeginUpdate;
ListViewGroupe.Items[AItem.Index].Checked:=not ListViewGroupe.Items[AItem.Index].Checked;
Status:=ListViewGroupe.Items[AItem.Index].Checked;
AListItemText:=ListViewGroupe.Items[AItem.Index].Objects.TextObject;
AListTextButton:=ListViewGroupe.Items[AItem.Index].Objects.TextButton;
if Status then begin
            AListTextButton.Text:='Dslection';
            AListItemText.Font.Style:=[TFontStyle.fsBold];
          end
          else begin
            AListTextButton.Text:='Slection';
            AListItemText.Font.Style:=[];
          end;
for I := AItem.Index+1 to ListViewGroupe.Items.Count-1 do
  begin
    if  (ListViewGroupe.Items[i].Purpose=TListItemPurpose.Header)
     OR (ListViewGroupe.Items[i].Purpose=TListItemPurpose.Footer)
       then Break;
    ListViewGroupe.Items.SetChecked(i,Status);
    AListItemText:=ListViewGroupe.Items[i].Objects.TextObject;
    if Status then AListItemText.Font.Style:=[TFontStyle.fsBold]
              else AListItemText.Font.Style:=[];
  end;
ListViewGroupe.EndUpdate;
end;

procedure TMainForm.ListViewGroupeItemClick(const Sender: TObject;
  const AItem: TListViewItem);
var  AListItemText : TListItemText;
     AButton       : TListItemTextButton;
begin
case AItem.Purpose of
   TListItemPurpose.None : begin
   if not ListViewGroupe.EditMode then
    ListViewGroupe.Items.SetChecked(AItem.Index,not Aitem.Checked);
    AListItemText:=AItem.Objects.TextObject;
    if AItem.Checked
        then AListItemText.Font.Style:=[TFontStyle.fsBold]
       else AListItemText.Font.Style:=[];
   end;
 // else header / footer
 end;
end;

procedure TMainForm.LstViewAvecImageItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
if not LstViewAvecImage.EditMode then
  LstViewAvecImage.Items.SetChecked(AItem.Index,not Aitem.Checked);
 if AItem.Checked then AItem.ImageIndex:=0 else AItem.ImageIndex:=-1;
end;

procedure TMainForm.LstViewDyn_plusItemClick(const Sender: TObject;
  const AItem: TListViewItem);
begin
LstViewDyn_plus.Items.SetChecked(AItem.Index,not Aitem.Checked);
UpdateItem(AItem);
end;


procedure TMainForm.Switch1Switch(Sender: TObject);
var CheckedList : TArray<Integer>;
    i : Integer;
begin
CheckedList:=LstViewSimple.Items.CheckedIndexes(True);
Switch2.Visible:=Switch1.IsChecked;
LstViewSimple.EditMode:=Switch1.IsChecked;
for i in CheckedList do LstViewSimple.Items.SetChecked(i,true);
end;

procedure TMainForm.Switch2Switch(Sender: TObject);
begin
lstViewSimple.ItemAppearanceObjects.ItemEditObjects.GlyphButton.Visible:=Switch2.IsChecked;
end;

procedure TMainForm.Switch3Switch(Sender: TObject);
var CheckedList : TArray<Integer>;
    i : Integer;
    Item : TAppearanceListViewItem;
    ACheckBox : TListItemGlyphButton;
begin
CheckedList:=LstViewDyn.Items.CheckedIndexes(True);
LstViewDyn.EditMode:=Switch3.IsChecked;
for i in CheckedList do LstViewDyn.Items.SetChecked(i,true);
if LstViewDyn.EditMode then
 begin
   LstViewDyn.BeginUpdate;
   for I:=0 to LstViewDyn.Items.Count-1 do
     begin
      Item:=LstViewDyn.Items[i];
      ACheckbox:=Item.Objects.FindObjectT<TListItemGlyphButton>('GlyphButton2');
      if Assigned(ACheckBox) AND (ACheckBox.ButtonType=TGlyphButtonType.Checkbox)
        then ACheckBox.Checked:=Item.Checked;
     end;
    LstViewDyn.EndUpdate;
 end;
end;

end.
